<!DOCTYPE html>
<html>
<head>
	<meta charset="utf-8">
	<meta name="viewport" content="width=device-width, initial-scale=1">
	<title>Carrito de compras - Muebleria Lucy</title>
	<link rel="icon" type="text/css" href="img/icono.png">
	<link rel="stylesheet" type="text/css" href="src/bootstrap-5.1.3-dist/css/bootstrap.min.css">
	<link rel="stylesheet" type="text/css" href="src/bootstrap-icons-1.8.1/bootstrap-icons.css">
	<link rel="stylesheet" type="text/css" href="css/styles.css">
	<script type="text/javascript" src="src/bootstrap-5.1.3-dist/js/bootstrap.min.js"></script>
	<script src="https://www.paypal.com/sdk/js?client-id=test&currency=USD"></script>
    
</head>
<body>
	<!--MODALS-->
	<div>
		
	</div>
	<header  id="cabecera">
	</header>
	<main class="container mt-3">
		<h1><i class="bi bi-cart"></i>Mi carrito</h1>
		<div class="row">
			<div class="col-md-8">
				<table class="table table-responsive table-sm">
					<thead class="table-dark">
						<tr>
							<th>PRODUCTO</th>
							<th>PRECIO</th>
							<th>CANTIDAD</th>
							<th colspan="2">TOTAL</th>
						</tr>
					</thead>
					<tbody id="tabla_datos_carrito">
						<!--tr>
							<td>Mueble</td>
							<td>S/ 100.00</td>
							<td>
								<div class="input-group">
								  <button class="btn btn-sm btn-primary" type="button" id="button-addon1" onclick="modificarStock('id',-1)"><i class="bi bi-dash-lg font-bold"></i></button>
								  <input type="number" id="stock_id" class="cantidaCarrito" min="1" value="1" onchange="validarNegativos(this)">
								  <button class="btn btn-sm btn-primary" type="button" id="button-addon2" onclick="modificarStock('id', 1)"><i class="bi bi-plus-lg font-bold"></i></button>
								</div>
							</td>
							<td>S/ <span id="total_id">100</span>
								<button type="button" class="btn btn-sm btn-danger rounded-circle">
									<i class="bi bi-x-lg"></i>
								</button>
							</td>
						</tr-->
					</tbody>
				</table>
			</div>
			<div class="col-md-4">
				<div class="card pt-3 pb-3" style="text-align: right;">
					<div class="card-body">
						<div class="row">
							<div class="col-6">
								<label>Subtotal</label>
							</div>
							<div class="col-6">
								<label id="txtSubtotal">S/ 0</label>
							</div>
						</div>
						<hr class="m-1">
						<div class="row" style="font-weight: bolder; color: black; font-size: 1rem;">
							<div class="col-6">
								<label>Total</label>
							</div>
							<div class="col-6">
								<label>S/ <span id="precioTotal">0</span></label>
							</div>
						</div>
					</div>
				</div>
			    <div id="paypal-button-container"></div>
			</div>
		</div>
	  <!-- FOOTER -->
	  <footer class="container">
	    <p class="float-end"><a href="#">Regresar arriba</a></p>
	    <p>© 2022 Muebleria Lucy</p>
	  </footer>
	</main>


<script type="text/javascript" src="src/jquery-3.6.0/jquery-3.6.0.min.js"></script>
<script type="text/javascript" src="js/util.js"></script>
<script type="text/javascript" src="js/scripts.js"></script>
<script type="text/javascript" src="js/index.js"></script>
<script type="text/javascript">
	$(document).ready(function() {
		cargarCarrito()
	});

	function cargarCarrito() {
		$.get('functions/CargarCarrito.php', function(data) {
			let response = JSON.parse(data);
			if (response.codigoRespuesta==0) {
				response.listaCarrito.forEach( function(element, index) {
					let listaProds = `<tr id='fila_${element.idCarrito}'>
							<td>${element.nombreMueble}</td>
							<td>S/ ${element.precioUnitario}</td>
							<td>
								<div class="input-group">
								  <button class="btn btn-sm btn-primary" type="button" id="button_remove_${element.idCarrito}" onclick="modificarStock('${element.idCarrito}',-1)"><i class="bi bi-dash-lg font-bold"></i></button>
								  <input type="number" id="stock_${element.idCarrito}" class="cantidaCarrito" min="1" value="${element.cantidad}" onchange="validarNegativos(this,'${element.idCarrito}')">
								  <button class="btn btn-sm btn-primary" type="button" id="button_add_${element.idCarrito}" onclick="modificarStock('${element.idCarrito}', 1)"><i class="bi bi-plus-lg font-bold"></i></button>
								</div>
							</td>
							<td>S/ <span id="total_${element.idCarrito}">${element.total}</span>
								<button type="button" class="btn btn-sm btn-danger rounded-circle" onclick="eliminarProducto(${element.idCarrito})">
									<i class="bi bi-x-lg"></i>
								</button>
							</td>
						</tr>`;
					$("#tabla_datos_carrito").append(listaProds);
					cargarTotales();
				});
			}else{
				mostrarMensaje(response.mensajeRespuesta,'danger');
			}	
		});
	}
	function validarNegativos(obj,idCarrito){
		let cantidad = parseInt($("#"+obj.id).val());
		if (cantidad<1) {
			cantidad = 1;
			$("#"+obj.id).val(cantidad);
		}
		$.post('functions/ModificarStock.php', {idCarrito,"cantidad":cantidad}, function(data, textStatus, xhr) {
				let response = JSON.parse(data);
				if (response.codigoRespuesta==0) {
					$("#total_"+idCarrito).text(response.totalNuevo);
					$("#stock_"+idCarrito).val(nuevaCantidad);
					cargarTotales();
				}else{
					mostrarMensaje(response.mensajeRespuesta,'danger');
				}
			});
	}
	function cargarTotales(){
		$.get('functions/CalcularTotales.php', function(data) {
			let response = JSON.parse(data);
			if (response.codigoRespuesta==0) {
				$("#txtSubtotal").text(response.subtotal)
				$("#precioTotal").text(response.totalFinal)			
			}else{
				mostrarMensaje(response.mensajeRespuesta,'danger');
			}

		});
	}

	function modificarStock (idCarrito, cantidad) {
		$("#button_remove").attr('disabled', 'true').html(`<span class="spinner-grow spinner-grow-sm" role="status" aria-hidden="true"></span>`)
		$("#button_add").attr('disabled', 'true').html(`<span class="spinner-grow spinner-grow-sm" role="status" aria-hidden="true"></span>`)
		let nuevaCantidad = parseInt($("#stock_"+idCarrito).val())+cantidad;
		if (nuevaCantidad>0) {
			$.post('functions/ModificarStock.php', {idCarrito,"cantidad":nuevaCantidad}, function(data, textStatus, xhr) {
				let response = JSON.parse(data);
				if (response.codigoRespuesta==0) {
					$("#total_"+idCarrito).text(response.totalNuevo);
					$("#stock_"+idCarrito).val(nuevaCantidad);
					cargarTotales();
				}else{
					mostrarMensaje(response.mensajeRespuesta,'danger');
				}
				$("#button_remove").removeAttr('disabled').html(`<i class="bi bi-dash-lg font-bold"></i>`)
				$("#button_add").removeAttr('disabled').html(`<i class="bi bi-plus-lg font-bold"></i>`)
			});
		}
	}

	function registrarCompra(){
		let precioFinal = $("#precioTotal").text();
		$.post('functions/RegistrarCompra.php', {precioFinal}, function(data, textStatus, xhr) {
			let response = JSON.parse(data);
			if (response.codigoRespuesta==0) {
				location.href = "misCompras.html";
			}else{
				alert(response.mensajeRespuesta);
			}
		});
	}

	function eliminarProducto(idCarritoDetalle){
		if(confirm("¿Desea quitar el producto del carrito?")){
			$.post('functions/BorrarProductoCarrito.php', {'idCarrito': idCarritoDetalle}, function(data, textStatus, xhr) {
				let response = JSON.parse(data);
				alert(response.mensajeRespuesta);
				if (response.codigoRespuesta==0) {
					$("#fila_"+idCarritoDetalle).remove();
					cargarTotales();
				}
			});
		}
	}

	paypal.Buttons({
      // Set up the transaction
      createOrder: function(data, actions) {
      		let totalPago = Math.round((parseFloat($("#precioTotal").text())/3.65) * 100) / 100;
      		console.log("Total:"+totalPago)
          return actions.order.create({
              purchase_units: [{
                  amount: {
                      value:  totalPago
                  }
              }]
          });
      },

      // Finalize the transaction
      onApprove: function(data, actions) {
          return actions.order.capture().then(function(orderData) {
              
              console.log('Capture result', orderData, JSON.stringify(orderData, null, 2));
              var transaction = orderData.purchase_units[0].payments.captures[0];
              //alert('Transaction '+ transaction.status + ': ' + transaction.id + '\n\nSee console for all available details');
              registrarCompra();

          });
      }


  }).render('#paypal-button-container');
</script>
</body>
</html>